test: console logs to file
Test for the logging feature of obmc-console-server.
Change-Id: I9836727a944a0351962133baa2fd2ff5eb60e67f
Signed-off-by: Andrew Jeffery <andrew@codeconstruct.com.au>
Signed-off-by: Alexander Hansen <alexander.hansen@9elements.com>
diff --git a/test/test-console-logs-to-file b/test/test-console-logs-to-file
new file mode 100755
index 0000000..ffedbd9
--- /dev/null
+++ b/test/test-console-logs-to-file
@@ -0,0 +1,47 @@
+#!/usr/bin/sh
+
+set -eux
+
+SOCAT="$1"
+SERVER="$2"
+
+# Meet DBus bus and path name constraints, append own PID for parallel runs
+TEST_NAME="$(basename "$0" | tr '-' '_')"_${$}
+TEST_DIR="$(mktemp --tmpdir --directory "${TEST_NAME}.XXXXXX")"
+PTYS_PID=""
+SERVER_PID=""
+
+cd "$TEST_DIR"
+
+cleanup()
+{
+ [ -z "$SERVER_PID" ] || kill -s INT "$SERVER_PID"
+ [ -z "$PTYS_PID" ] || kill "$PTYS_PID"
+ wait
+ cd -
+ rm -rf "$TEST_DIR"
+}
+
+trap cleanup EXIT
+
+TEST_CONF="${TEST_NAME}.conf"
+TEST_LOG="${TEST_NAME}.log"
+
+cat <<EOF > "$TEST_CONF"
+active-console = $TEST_NAME
+[$TEST_NAME]
+logfile = $TEST_LOG
+console-id = $TEST_NAME
+EOF
+
+"$SOCAT" -u PTY,raw,echo=0,link=remote PTY,raw,echo=0,wait-slave,link=local &
+PTYS_PID="$!"
+while ! [ -e remote ] || ! [ -e local ]; do sleep 1; done
+
+"$SERVER" --config "$TEST_CONF" "$(realpath local)" &
+SERVER_PID="$!"
+while ! busctl status --user xyz.openbmc_project.Console."${TEST_NAME}"; do sleep 1; done
+
+echo console-should-log-to-file > remote
+sleep 1
+grep -LF console-should-log-to-file "$TEST_LOG"